#include <math.h>
#define ACC 40.0 
#define BIGNO 1.0e10
#define BIGNI 1.0e-10

double bessi0(double x);

double bessi(int n, double x) {
	int j;
	double bi,bim,bip,tox,ans,bsi0x;

	if (n < 2) exit(1);
	if (x == 0.0)
		return 0.0;
	else {
		tox=2.0/fabs(x);
		bip=ans=0.0;
		bi=1.0;
		for (j=2*(n+(int)sqrt(ACC*n));j>0;--j) { 
			bim=bip+j*tox*bi;
			bip=bi;
			bi=bim;
			if (fabs(bi) > BIGNO) {
				ans *= BIGNI;
				bi *= BIGNI;
				bip *= BIGNI;
			}
			if (j == n) ans=bip;
		}
		bsi0x = bessi0(x);
		ans *= bsi0x/bi;
		if (x < 0.0 && n != ((int)n/2)*2) return -ans;
		else return ans;
	}
}

double bessi0(double x) {
	double ax,ans;
	double y;

	ax=fabs(x);
	if (ax < 3.75) {
		y=x/3.75;
		y*=y;
		ans=1.0+y*(3.5156229+y*(3.0899424+y*(1.2067492+y*(0.2659732+y*(0.360768e-1+y*0.45813e-2)))));
	} else {
		y=3.75/ax;
		ans=(exp(ax)/sqrt(ax))*(0.39894228+y*(0.1328592e-1+y*(0.225319e-2+y*(-0.157565e-2+y*(0.916281e-2+y*(-0.2057706e-1+y*(0.2635537e-1+y*(-0.1647633e-1+y*0.392377e-2))))))));
	}
	return ans;
}

